diff a/src/java.base/share/classes/java/lang/ref/Reference.java b/src/java.base/share/classes/java/lang/ref/Reference.java
--- a/src/java.base/share/classes/java/lang/ref/Reference.java
+++ b/src/java.base/share/classes/java/lang/ref/Reference.java
@@ -305,10 +305,14 @@
         handler.setDaemon(true);
         handler.start();
     }
 
     static {
+        runtimeSetup();
+    }
+
+    private static void runtimeSetup() {
         // provide access in SharedSecrets
         SharedSecrets.setJavaLangRefAccess(new JavaLangRefAccess() {
             @Override
             public void startThreads() {
                 ThreadGroup tg = Thread.currentThread().getThreadGroup();
